' **************************************************************************
' PortugalTV.vbs v1.2
' **************************************************************************

' Retreives TV listings for Portugal from
' http://www.tvcabo.pt/home_televisao.asp
'
' This script is written for Samurize 0.85b. I cannot guarantee that it will
' work with any earlier versions of Samurize.

'                                                             - NeM

' **************************************************************************
'       Check out NeM Portal. http://samurize.breezeland.com/e107/
' **************************************************************************

' =====================
' INSTRUCTIONS FOR USE:
' =====================

' INSTALLATION:
' -------------

' 1) Unzip/copy PortugalTV.vbs to your Samurize/Scripts folder
'
' 
' USAGE:
' ------

' Use a meter with the getListing function to update your TV listings. This
' function will update the listings for an entire week, so you should only
' have to run it every 6-7 days.
'
' *NOTE* Do NOT set this meter to update every few minutes! Every TV channel
' page is 100-200kb in size to download so you will waste a LOT of traffic
' updating it every few minutes!! Ideally you should just manually update it
' every few days instead of having Samurize run it as an ActiveScript. There
' is a script included called PortugalTV_UpdateChannel.vbs that takes a single
' commandline parameter, a channel code. This script will download and create
' the .tmp files for you, so you can update channels at the click of a button
' using Samurize meter linkage or Windows Task Scheduler.
'
' eg. for RTP1, use
'     C:\Program Files\Samurize\PortugalTV_UpdateChannel.vbs 5
'
' Note: you may need to adjust the path to your Samurize folder in
' PortugalTV_UpdateChannel.vbs
'
' To obtain the listing for a particular channel, add a meter with either
' the whatsOnNow or whatsOnNext function, corresponding to what is currently
' showing on TV and what is coming up next. Enter the channel's code number
' you want listings for as the channelCode parameter. Check the valid channel 
' codes in the channelcodes.txt file included with this zip file.

' Thanks to Alderaic for his trimHTML function

' CHANGES IN v1.2:
' ----------------
' - miniscript to update channels using meter linkage/Windows Task Scheduler

' CHANGES IN v1.1:
' ----------------
'
' - fixed URLS - the URLs for the listings etc changed
' - fixed code to work with new site layout

' **************************************************************************

' =============
' USER SETTINGS
' =============
SHOW_EXTRA_DETAILS = True	' set to false if you don't want episode information etc. displayed







' *********************************************************************
' DO NOT MODIFY CODE PAST THIS POINT UNLESS YOU KNOW WHAT YOU ARE DOING
' *********************************************************************

TV_URL = "http://www.tvcabo.pt/tv_cabo_progr_canal.asp?identificadorCanal="
TMP_FILE = "portugalTV.tmp"
CHECK = "<TITLE>TV Cabo"

Function getListing (channelCode)

	htmlResult = GetHTMLValue(TV_URL & channelCode)
	
	checkFile = InStr(htmlResult, CHECK)
	
	If checkFile > 0 Then
	
	
		set fs=CreateObject("Scripting.FileSystemObject")
		Set f=fs.CreateTextFile(channelCode & TMP_FILE,True)
		f.write(htmlResult)
		f.close
		set f=nothing
		set fs=nothing

		getListing = "Listings for channelCode " & channelCode & " updated to " & channelCode & TMP_FILE
	
	Else
		getListing = "Site format has changed."
	End If
	
End Function

Function whatsOnNow (channelCode)
	currentTime = getTime
	todaysDate = Day(Date)

	htmlResult = readFile(channelCode & TMP_FILE)

	checkString = "<TITLE>TV Cabo"
	channelPos = InStr(htmlResult, checkString)

	If channelPos > 0 Then

		' Check if temp file is up-to-date
		If InStr(htmlResult, " - " & todaysDate) < 1 Then
			whatsOnNow = "Temp file needs updating, or channel listings are not available."
			Exit Function
		End If

		backuphtml = htmlResult ' save for getting the show title

		' jump to right position
		htmlResult = mid(htmlResult, InStr(htmlResult, " - " & todaysDate))

		' skip to first time
		htmlResult = mid(htmlResult, InStr(htmlResult, " sans-serif;"">")+1)
		
		lastTime = "null"
		continueFlag = true
		timePos = 1
		
		Do While continueFlag
		
			timePos = InStr(timePos, htmlResult, ":") - 2
			tempTime = Mid(htmlResult, timePos, 5)

			' fix up for last show on a day
			if Not IsNumeric(Mid(tempTime, 1, 2)) then
				currenttime="00:00"
				tempTime=lastTime
				'oldTimePos = timePos
			end if




			If timeGreaterThan(tempTime, currentTime) Then

				If oldtimepos<1 Then
					'current show is the last on the previous day

					lastTime = "null"
					continueFlag = true
					timePos = 1
					currentTime = "23:59"


					todaysDate=todaysDate-1
					


					' jump to right position
					backuphtml = mid(backuphtml, InStr(backuphtml, " - " & todaysDate))

					' skip to first time
					backuphtml = mid(backuphtml, InStr(backuphtml, " sans-serif;"">")+1)


					Do While continueFlag

						timePos = InStr(timePos, backuphtml, ":") - 2
						tempTime = Mid(backuphtml, timePos, 5)


						' fix up for last show on a day
						if Not IsNumeric(Mid(tempTime, 1, 2)) then
							currenttime="00:00"
							tempTime=lastTime
							'oldTimePos = timePos
						end if


						If timeGreaterThan(tempTime, currentTime) Then

							' lastTime must correspond to the current showing program
							continueFlag = false'

						Else
							' keep searching
							lastTime = tempTime

							oldTimePos = timePos
							timePos = InStr(timePos, backuphtml, " sans-serif;"">")+1

						End If
					Loop

					' found time, now get TV show title
					tvshowStartPos = InStr(oldtimePos, backuphtml, "&nbsp;") + 6
					tvShowEndPos = InStr(tvShowStartPos, backuphtml, "</td>")

					' grab show name
					tvShowName = Mid(backuphtml,tvshowStartPos, (tvShowEndPos - tvshowStartPos))


					' fix up special characters
					tvShowName = fixChars(tvShowName)

					' remove any HTML tags
					tvShowName = TrimHTML(tvShowName)
		
					whatsOnNow = "(" & lastTime & ") " & tvShowName
					exit function





				End If

				' lastTime must correspond to the current showing program
				continueFlag = false

			Else
				' keep searching
				lastTime = tempTime

				oldTimePos = timePos

				timePos = InStr(timePos, htmlResult, " sans-serif;"">")+1
			End If

		Loop

		' found time, now get TV show title
		tvshowStartPos = InStr(oldtimePos, htmlResult, "&nbsp;") + 6
		tvShowEndPos = InStr(tvShowStartPos, htmlResult, "</td>")

		' grab show name
		tvShowName = Mid(htmlResult,tvshowStartPos, (tvShowEndPos - tvshowStartPos))


		' fix up special characters
		tvShowName = fixChars(tvShowName)

		' remove any HTML tags
		tvShowName = TrimHTML(tvShowName)
		
		whatsOnNow = "(" & lastTime & ") " & tvShowName

	else
		' checkString not found!
		whatsOnNow = "Unavailable"

	end if

End Function

Function whatsOnNext (channelCode)
	currentTime = getTime

	htmlResult = readFile(channelCode & TMP_FILE)

	checkString = "<TITLE>TV Cabo"
	channelPos = InStr(htmlResult, checkString)

	If channelPos > 0 Then

		' Check if temp file is up-to-date
		If InStr(htmlResult, " - " & Day(Date)) < 1 Then
			whatsOnNext = "Temp file needs updating, or channel listings are not available."
			Exit Function
		End If

		' jump to right position
		htmlResult = mid(htmlResult, InStr(htmlResult, " - " & Day(Date)))

		' skip to first time
		htmlResult = mid(htmlResult, InStr(htmlResult, " sans-serif;"">")+1)
		
		lastTime = "null"
		continueFlag = true
		timePos = 1
		
		Do While continueFlag
		
			timePos = InStr(timePos, htmlResult, ":") - 2
			tempTime = Mid(htmlResult, timePos, 5)


			'fix for next show the first on next day
			Do While Not IsNumeric(Mid(tempTime, 1, 2))
				currentTime = "00:00"

				timePos = InStr(timePos, htmlResult, ":") - 2
				tempTime = Mid(htmlResult, timePos, 5)
				timepos = timepos+5

			Loop



			If timeGreaterThan(tempTime, currentTime) Then
				' lastTime must be the current showing time
				continueFlag = false
			Else
				' keep searching
				lastTime = tempTime

				oldTimePos = timePos


				timePos = InStr(timePos, htmlResult, " sans-serif;"">")+1
			End If

		Loop
		
		' found time, now get TV show title
		tvshowStartPos = InStr(timePos, htmlResult, "&nbsp;") + 6
		tvShowEndPos = InStr(tvShowStartPos, htmlResult, "</td>")

		' grab show name
		tvShowName = Mid(htmlResult,tvshowStartPos, (tvShowEndPos - tvshowStartPos))

		' fix up special characters
		tvShowName = fixChars(tvShowName)

		' remove any HTML tags
		tvShowName = TrimHTML(tvShowName)
		
		whatsOnNext = "(" & tempTime & ") " & tvShowName

	else
		' checkString not found!
		whatsOnNext = "Unavailable"

	end if

End Function



Private Function timeGreaterThan(time1, time2)

	time1hr = CInt(mid(time1, 1, InStr(time1, ":")-1))
	time2hr = CInt(mid(time2, 1, InStr(time2, ":")-1))
	time1min = CInt(mid(time1, InStr(time1, ":") + 1, 2))
	time2min = CInt(mid(time2, InStr(time2, ":") + 1, 2))
	
	' fix for 12pm/am
	'If time1hr = 12 Then
	'	time1hr = 0
	'End If
	
	' 12:00pm - 12:59pm bug fix by blackout 28/04/2003 9:18PM
	'If time2hr = 12 Then
	'	time2hr = 0
	'End If

	If time1hr > time2hr Then
		' 1st time is bigger
		timeGreaterThan = True
		Exit Function
	End If
	
	If time1hr < time2hr Then
		' 2nd time is bigger
		timeGreaterThan = False
		Exit Function
	End If
	
	' must be in the same hour
	If time1min > time2min Then
		' 1st time is bigger
		timeGreaterThan = True
		Exit Function
	Else
		' 2nd time is bigger or equal
		timeGreaterThan = False
	End If

End Function



Private Function getTime()

	currentHour = Hour(Time)	
	currentMinute = Minute(Time)


	If currentHour < 10 Then
		' prepend 0
		currentHour = "0" & currentHour
	End If

	If currentMinute < 10 Then
		' prepend 0
		currentMinute = "0" & currentMinute
	End If

	getTime = currentHour & ":" & currentMinute
	
End Function

Private Function getHTMLValue(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	HTML = objXMLHTTP.responseBody
	Set objRS = CreateObject("ADODB.Recordset")
	objRS.Fields.Append "txt", 200, 45000, &H00000080
	objRS.Open
	objRS.AddNew
	objRS.Fields("txt").AppendChunk HTML
	getHTMLValue = objRS("txt").Value
	objRS.Close
	Set objRS = Nothing
	Set objXMLHTTP = Nothing
End Function

' FUnction to replace excape characters with their actual characters
Private Function fixChars(text)

	if SHOW_EXTRA_DETAILS = False And InStr(text, "&nbsp;")>0 Then
		text = mid(text, 1, InStr(text, "&nbsp;")-1)
	End If

	text = replace(text, "&#201;", "")
	text = replace(text, "&#234;", "")
	text = replace(text, "&#243;", "")
	text = replace(text, "&#226;", "")
	text = replace(text, "&#225;", "")
	text = replace(text, "&#227;", "")
	text = replace(text, "&#233;", "")
	text = replace(text, "&#218;", "")
	text = replace(text, "&#231;", "")
	text = replace(text, "&#237;", "")
	text = replace(text, "&#250;", "")
	text = replace(text, "&#193;", "")
	text = replace(text, "&#245;", "")
	text = replace(text, "&quot;", """")
	text = replace(text, "&nbsp;", " - ")
	text = replace(text, "&amp;", "&")
	text = replace(text, vbCrLf, "")
	text = replace(text, vbCr, "")
	text = replace(text, vbLf, "")
	text = replace(text, vbTab, "")


	fixChars = text
End Function

Private Function readFile(fileName)

	dim contents

	Set fs = CreateObject ("Scripting.FileSystemObject")
        If (fs.FileExists(fileName)) Then
		Set filePath = fs.GetFile(fileName)
		set File = filePath.OpenAsTextStream (1, -2)

		contents = file.readall

		File.Close
		Set filePath = nothing
		Set fs = nothing
		Set File = nothing
	Else 	
		readFile = "File doesn't exist"
		Exit Function
        End If

	' return file contents
	readFile = contents

End Function

' ******************************
' Following function by Alderaic
' ******************************

'very simple function that will remove all html tags
Private Function TrimHTML(str)
pos_deb = InStr(1, str, "<")
Do Until pos_deb = 0
    pos_fin = InStr(pos_deb, str, ">")
    part_d = Mid(str, 1, pos_deb - 1)
    part_f = Mid(str, pos_fin + 1, Len(str) - pos_fin)
    str = part_d & part_f
    pos_deb = InStr(1, str, "<")
Loop
TrimHTML = Trim(str)
End Function